Bug 1165641 - Review Request: perl-Text-BibTeX - Interface to read and parse BibTeX files
Summary: Review Request: perl-Text-BibTeX - Interface to read and parse BibTeX files
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Petr Šabata
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1165631 1165634
Blocks: 1165620
TreeView+ depends on / blocked
 
Reported: 2014-11-19 12:15 UTC by Colin Macdonald
Modified: 2014-12-23 18:26 UTC (History)
2 users (show)

Fixed In Version: perl-Text-BibTeX-0.70-4.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-12-23 18:26:39 UTC
psabata: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Colin Macdonald 2014-11-19 12:15:28 UTC
Spec URL: https://github.com/cbm755/fedora-spec/blob/master/perl-Text-BibTeX.spec
SRPM URL: http://people.maths.ox.ac.uk/macdonald/fedora/perl-Text-BibTeX-0.70-1.fc21.src.rpm

Description: <description here>
The Text::BibTeX module serves mainly as a high-level introduction to the
Text::BibTeX library, for both code and documentation purposes. The code
loads the two fundamental modules for processing BibTeX files
(Text::BibTeX::File and Text::BibTeX::Entry), and this documentation gives
a broad overview of the whole library that isn't available in the
documentation for the individual modules that comprise it.

Fedora Account System Username: cbm

This is dep for Biber, bug #1165620

I need sponsorship, but I'm not a perl user so I'm equally happy for perl people to take this one.

koji fails because of dependencies

Comment 1 Colin Macdonald 2014-11-19 12:57:44 UTC
rpmlint is really unhappy with this one!

I guess the bundled btparse library should be packaged separately?

Comment 2 Colin Macdonald 2014-11-19 23:48:12 UTC
Ignore previous comment.

But I think I need some help with this one!  In particular, the unversioned shared lib "/usr/lib64/libbtparse.so"...

Here's my best effort so far:

http://people.maths.ox.ac.uk/macdonald/fedora/perl-Text-BibTeX-0.70-2.fc21.src.rpm

https://github.com/cbm755/fedora-spec/blob/master/perl-Text-BibTeX.spec

Comment 3 Petr Šabata 2014-11-20 15:38:37 UTC
Since the btparse library is available as a standalone project, you should really package it separately, unbundle it and depend on the other btparse package.  You'll also have to patch Build.PL to use the external library.

I'll comment on the rest for now.

#1 btool_faw.pod seems to be useful.  Add it to %doc.

#2 Some BRs are missing.
From Build.PL and inc/MyBuilder.pm (loaded by Build.PL): perl(base), perl(Config), perl(ExtUtils::Mkbootstrap), perl(ExtUtils::ParseXS), perl(File::Copy), perl(File::Path), perl(File::Spec::Functions) and perl(lib).

#3 Tip: That shebang substitution could be done in one go, e.g. sed -ri 's#/usr/local/bin/perl5?#%{__perl}#' scripts/* examples/*; and similar for that chmod.

#4 About your first FIXME: Indeed, you should move this to a separate package, see above.

#5 About your second FIXME: These are also provided by btparse.  We probably want them but not here.

#6 About your third FIXME: `xscode' is a mapping between the perl code and the C library.  It creates the BibTeX.so file.  This is fine and you don't have to worry about it.

#7 After you unbundle the library, you won't need chrpath nor %{_mandir}/man1/*, %{_bindir}/* and %{_libdir}/*.so in you %files section.  This is probably obvious :)

Comment 4 Petr Šabata 2014-11-20 20:50:49 UTC
Oops, I've just noticed the last release of the standalone btparse it really, really old.  And according to Text::BibTeX's changelog (v0.40_2, from 2010), it is now a part of this package.

So scratch what I said about unbundling in the previous comment -- keep it.  Keep the unversioned library too; upstream doesn't provide anything else.  We also want the installed binaries.

I'll take another look at this tomorrow.

Comment 5 Colin Macdonald 2014-11-22 00:36:25 UTC
#3: not so easy, its "perl5" and "perl".

Need man pages for the three utilities as per rpmlint?

A further iteration:

http://people.maths.ox.ac.uk/macdonald/fedora/perl-Text-BibTeX-0.70-3.fc21.src.rpm

https://raw.githubusercontent.com/cbm755/fedora-spec/master/perl-Text-BibTeX.spec

Comment 6 Petr Šabata 2014-11-24 15:13:16 UTC
(In reply to Colin Macdonald from comment #5)
> #3: not so easy, its "perl5" and "perl".

That's why I call sed with `-r' and use `perl5?' in the expression :) That should work fine.

> Need man pages for the three utilities as per rpmlint?

Not unless you want to write them.

> A further iteration:
> 
> http://people.maths.ox.ac.uk/macdonald/fedora/perl-Text-BibTeX-0.70-3.fc21.
> src.rpm
> 
> https://raw.githubusercontent.com/cbm755/fedora-spec/master/perl-Text-BibTeX.
> spec

I dare to approve this now.  There isn't much you can do about that libbtparse.so (besides working with upstream and convincing them to version their ABI).

Comment 7 Colin Macdonald 2014-11-24 17:30:00 UTC
I see.  I'd rather concentrate on getting biber in for now.  Perhaps return to this issue later.

Is it complicated to put it in /usr/lib64/btparse/libbtparse.so or similar?  Docs refer to "rpath" for this...  But I readily admit I'm a bit over my head.

Comment 8 Colin Macdonald 2014-11-24 17:31:22 UTC
Oh, and I'll try your single-line sed before committing.

Comment 9 Colin Macdonald 2014-11-24 17:35:21 UTC
New Package SCM Request
=======================
Package Name: perl-Text-BibTeX
Short Description: Interface to read and parse BibTeX files
Upstream URL: http://search.cpan.org/dist/Text-BibTeX/
Owners: cbm mef
Branches: f21
InitialCC: perl-sig

Comment 10 Colin Macdonald 2014-11-24 17:35:52 UTC
New Package SCM Request
=======================
Package Name: perl-Text-BibTeX
Short Description: Interface to read and parse BibTeX files
Upstream URL: http://search.cpan.org/dist/Text-BibTeX/
Owners: cbm mef
Branches: f21
InitialCC: perl-sig

Comment 11 Gwyn Ciesla 2014-11-24 20:47:52 UTC
Git done (by process-git-requests).

Comment 12 Petr Šabata 2014-11-25 10:03:41 UTC
(In reply to Colin Macdonald from comment #7)
> Is it complicated to put it in /usr/lib64/btparse/libbtparse.so or similar? 
> Docs refer to "rpath" for this...  But I readily admit I'm a bit over my
> head.

Judging by the docs, I think the library is meant to be used by other developers, if they wish to do so (despite the unversioned ABI).  For this reason, I would keep it in %{_libdir} (and delete rpath from the binaries).

If you think nobody but Text::BibTeX will ever use it, feel free to move it to a subdirectory (and utilize rpath in the binaries to find it; that is acceptable).  You will have to tinker with the package build system for this.

It can be done either way.  I prefer the first, option -- what we have now.

Comment 13 Colin Macdonald 2014-11-25 11:13:15 UTC
> I prefer the first, option -- what we have now.

Ok, thanks!

Comment 14 Fedora Update System 2014-12-07 00:36:30 UTC
perl-Text-BibTeX-0.70-3.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/perl-Text-BibTeX-0.70-3.fc21

Comment 15 Fedora Update System 2014-12-12 04:35:04 UTC
perl-Text-BibTeX-0.70-3.fc21 has been pushed to the Fedora 21 testing repository.

Comment 16 Fedora Update System 2014-12-13 11:14:54 UTC
perl-Text-BibTeX-0.70-4.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/perl-Text-BibTeX-0.70-4.fc21

Comment 17 Fedora Update System 2014-12-23 18:26:39 UTC
perl-Text-BibTeX-0.70-4.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.